<script>
export default {
  name: `cbr-modal`,
  props: {
    value: { type: Boolean, required: true },
    title: { type: String, required: true },
    onConfirm: { type: Function, default: null },
    onCancel: { type: Function, required: true },
    confirmText: { type: String, default: `Confirm` },
    cancelText: { type: String, default: `Cancel` },
    confirmColor: { type: String, default: `green darken-1` },
    cancelColor: { type: String, default: null },
    confirmIsDisabled: { type: Boolean, default: false },
    confirmIsHidden: { type: Boolean, default: false },
    scrollable: { type: Boolean, default: false },
    maxWidth: { type: Number, default: 320 },
  },
  computed: {
    localModel: {
      get() {
        return this.value;
      },
      set(newValue) {
        this.$emit(`input`, newValue);
      },
    }
  },
}
</script>

<template>
  <v-dialog v-model="localModel" :max-width="maxWidth" :scrollable="scrollable">
    <v-card>
      <v-card-title class="headline">
        {{ title }}
      </v-card-title>
      <v-card-text>
        <slot />
      </v-card-text>
      <v-card-actions>
        <v-spacer />
        <v-btn
          :color="cancelColor"
          outlined
          @click.stop="onCancel"
        >
          {{ cancelText }}
        </v-btn>
        <v-btn
          v-if="!confirmIsHidden"
          :color="confirmColor"
          @click.stop="onConfirm"
          :disabled="confirmIsDisabled"
        >
          {{ confirmText }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
